
let current = GetCurrentScriptDirectory;



let bg1 = current~"cdbg0.png";
let bg2 = current~"cdbg1.png";

let fade = 0;
let a = GetEnemyBossSceneObjectID;
let SpellActive = (a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL));
let IsLocalScriptStopped = false;
let quality = GetCommonData("quality", 2);

@Initialize{
	SetCommonData("EffectSpeed", 1);
	SetCommonData("BGMod", 1);
	SpellBG;
}
@MainLoop{
	SpellActive = (a != ID_INVALID && ObjEnemyBossScene_GetInfo(a, INFO_IS_SPELL));
	yield;
}


task SpellBG{
	let pathShader = current~"../../../ds_system/shader/warp.hlsl";
	let bg_spin = 0;
	let mov = 0;
	let vertexcount = 48+quality*64;
	
	let cdbg1a1 = CreateBackgroundImageA1(bg1, 256, 0.27, 1);
	ObjSprite2D_SetSourceRect(cdbg1a1, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjSprite2D_SetDestRect(cdbg1a1, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjRender_SetPosition(cdbg1a1, 0, 0, 0);
	ObjRender_SetColor(cdbg1a1, 128, 128, 144);
	ObjShader_SetShaderF(cdbg1a1, pathShader);
	ObjShader_SetTechnique(cdbg1a1, "TecMain");
	ObjShader_SetFloat(cdbg1a1, "p_int", 0.015);
	
	//let cdbg2a1 = CreateInfiniteBackground(bg2, vertexcount, 0.28, 0, 512, GetStgFrameWidth/2, GetStgFrameHeight/3);
	
	let cdbg2a1 = CreateBackgroundImageA1(bg2, 256, 0.28, 1);
	ObjRender_SetBlendType(cdbg2a1, BLEND_ALPHA);
	ObjSprite2D_SetSourceRect(cdbg2a1, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjSprite2D_SetDestRect(cdbg2a1, -32, -32, GetStgFrameWidth+32, GetStgFrameHeight+32);
	ObjRender_SetPosition(cdbg2a1, 0, 0, 0);
	ObjRender_SetColor(cdbg2a1, 96, 96, 128);
	ObjShader_SetShaderF(cdbg2a1, pathShader);
	ObjShader_SetTechnique(cdbg2a1, "TecMain");
	ObjShader_SetFloat(cdbg2a1, "p_int", 0.015);
	
	
	yield;
	// while(!IsCloseScript(GetScriptArgument("PluralID"))){
	while(true){
		a = GetEnemyBossSceneObjectID;
		
		if(SpellActive){
			fade = min(fade+12.75, 255)*GetCommonData("BGMod", 1);
		}else{
			fade=0;
		}
		
		ObjRender_SetAlpha(cdbg1a1, fade);
		ObjRender_SetAlpha(cdbg2a1, fade*0.6);
		
		mov+=0.25;
		ObjShader_SetFloat(cdbg1a1, "p_frame", mov*0.5);
		ObjShader_SetFloat(cdbg2a1, "p_frame", mov*0.5);
		ObjSprite2D_SetSourceRect(cdbg1a1, -32, -32-mov, GetStgFrameWidth+32, GetStgFrameHeight+32-mov);
		
		
		yield;
	}
	yield;
	IsLocalScriptStopped = true;
	//ScreenShatterA1(27, 28); //close scripts
	yield;
	Obj_Delete(cdbg1a1);
	Obj_Delete(cdbg2a1);
	yield;
	CloseScript(GetOwnScriptID);
	
	
}

let EffectSpeed = 1;
task CreateShadowEffectBrush{
	let frame = 0;
	while(!IsLocalScriptStopped){
		if(frame > 60 && SpellActive){CreateEffect;frame = 0;}
		frame += EffectSpeed;
		yield;
	}

	task CreateEffect{	
		let obj = CreateBackgroundImageA1(NULL, 1, 0.27, 1);
		ObjRender_SetBlendType(obj, BLEND_ADD_ARGB);
		
		let scl = rand(1.25, 1.75);
		ObjRender_SetScaleXYZ(obj, scl, scl, 1);
		ObjSprite2D_SetSourceRect(obj, 0, 0, 256, 256);
		ObjSprite2D_SetDestCenter(obj);
		
		let cmod = rand(0.1, 0.5);
		ObjRender_SetColor(obj, 192*cmod, 192*cmod, 128*cmod);
		
		let x = GetStgFrameWidth/2;
		let y = GetStgFrameHeight/2;
		let a = rand(0, 360);
		
		let xinc = rand(-0.35, 0.35);
		let yinc = rand(-0.35, 0.35);
		let ainc = rand(-0.14, 0.14);
		let sinc = 0.008;
		
		let duration = rand(160, 180);
		
		let ftime = 0;
		
		while(ftime < 60){
			ObjRender_SetAlpha(obj, 255/60*ftime);
			ftime += EffectSpeed;
			DoActions;
		}
		ftime = 0;
		while(ftime < duration-60){
			ObjRender_SetAlpha(obj, 255);
			ftime += EffectSpeed;
			DoActions;
		}
		ftime = 90;
		while(ftime > 0){
			ObjRender_SetAlpha(obj, 255/90*ftime);
			ftime -= EffectSpeed;
			DoActions;
		}
		
		Obj_Delete(obj);
		
		sub DoActions{
			x += xinc*EffectSpeed;
			y += yinc*EffectSpeed;
			a += ainc*EffectSpeed;
			scl += sinc*EffectSpeed;
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleZ(obj, a);
			ObjRender_SetScaleXYZ(obj, scl, scl, 1);
			if(IsLocalScriptStopped||!SpellActive){break;}
			yield;
		}
	}
}


function CreateInfiniteBackground(image, vertexcount, pri, innerrad, outerrad, lx, ly){
	let obj = ObjPrim_Create(OBJ_PRIMITIVE_2D);
	ObjPrim_SetPrimitiveType(obj, PRIMITIVE_TRIANGLESTRIP);
	ObjPrim_SetTexture(obj, image);
	Obj_SetRenderPriority(obj, pri);
	ObjPrim_SetVertexCount(obj, vertexcount);
	ObjRender_SetPosition(obj, lx, ly, 0);

	ascent(i in 0..vertexcount/2){
		let indexvert = i*2;
		let angle = 360/(vertexcount/2-1)*i;
		ObjPrim_SetVertexPosition(obj,indexvert+0,innerrad*cos(angle),innerrad*sin(angle),0);
		ObjPrim_SetVertexPosition(obj,indexvert+1,outerrad*cos(angle),outerrad*sin(angle),0);
	}
	return obj;
}


task ScreenShatterA1(minpri, maxpri){
	let renderTexture = "SpellBGShatter";
	let count = 0;
	let pathShader = GetMainStgScriptDirectory~"ds_system/shader/mask.hlsl";
	let pathMask = GetMainStgScriptDirectory~"ds_system/img/Masks/glass.png";
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	let objShader = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjShader_SetShaderF(objShader, pathShader);
	ObjShader_SetTechnique(objShader, "TecMask");

	ObjShader_SetTexture(objShader, "textureMask_", renderTexture);
	SetShaderI(objShader, maxpri, maxpri);
	
	let countx = 30;
	let county = 10;
	ascent(x in 0..countx){
		ascent(y in 0..county){
			CreateFragmentA1(GetStgFrameWidth/countx*x+rand(-16, 16), GetStgFrameHeight/county*y+rand(-16, 16));
		}
	}
	yield;
	while(count > 0){yield;}
	ObjShader_ResetShader(objShader);
	ResetShaderI(maxpri, maxpri);
	RemoveTexture(renderTexture);
	Obj_Delete(objShader);

	yield;
	CloseScript(GetOwnScriptID);
	
	
	task CreateFragmentA1(x, y){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjRender_SetBlendType(obj, BLEND_ALPHA);
		ObjRender_SetAlpha(obj, 255);
		Obj_SetRenderPriority(obj, maxpri/100);
		ObjPrim_SetTexture(obj, pathMask);
		let ranxy = [round(rand(0,7)), round(rand(0,7))];
		ObjRender_SetScaleXYZ(obj, 1.5, 1.5, 1.5);
		ObjSprite2D_SetSourceRect(obj, ranxy[0]*48, ranxy[1]*48, (ranxy[0]+1)*48, (ranxy[1]+1)*48);
		ObjSprite2D_SetDestCenter(obj);
		
		let mid = GetStgFrameWidth/2;
		let data = [0, 0, 0, 
		(((x-mid)/mid)*rand(0, 5) + rand(-1,1))*2, 
		(2-absolute((x-mid)/mid)*3+rand(-1, 2))*0.70];
		
		let datamov = [rand(-8, 8), rand(-8, 8), rand(-8, 8), 0, 0.022];
		ObjRender_SetPosition(obj, x, y, 0);
		ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
		while(y<GetStgFrameHeight+64&&x<GetStgFrameWidth+64&&x>-64){
			ObjRender_SetPosition(obj, x, y, 0);
			ObjRender_SetAngleXYZ(obj, data[0], data[1], data[2]);
			
			
			data += datamov;
			datamov[4] = datamov[4]*1.06;
			x += data[3];
			y += data[4];
			
			yield;
		}
		Obj_Delete(obj);
		count--;
	}
}

task ScreenZoomA1(minpri, maxpri){
	let renderTexture = "SpellBGZoom";
	let count = 0;
	if(!CreateRenderTarget(renderTexture)){
	RaiseError("Not enough VRAM to proceed.\nTry restarting the game and lowering the graphics quality.");}
		
	SetInvalidRenderPriorityA1(minpri, maxpri);
	Reset2DCamera;
	RenderToTextureA1(renderTexture, minpri, maxpri, true);
	ClearInvalidRenderPriority;
	
	ascent(i in 0..3){
		CreateShadowImage(renderTexture, 8*i, 1.4-0.2*i);
	}
	yield;
	while(count > 0){yield;}
	
	RemoveTexture(renderTexture);
	
	task CreateShadowImage(source, delay, scl){
		count++;
		let obj = ObjPrim_Create(OBJ_SPRITE_2D);
		Obj_SetRenderPriority(obj, maxpri);
		ObjPrim_SetTexture(obj, source);
		ObjSprite2D_SetSourceRect(obj, 32, 16, GetStgFrameWidth+32, GetStgFrameHeight+16);
		ObjSprite2D_SetDestRect(obj, 32, 16, GetStgFrameWidth+32, GetStgFrameHeight+16);
		ObjRender_SetPermitCamera(obj, false);
		
		ObjRender_SetAlpha(obj, 0);
		
		//ObjRender_SetAlpha(obj, 255);
		loop(delay){yield;}
		
		ObjRender_SetAlpha(obj, 255);
		
		scl--;
		
		ascent(i in 0..20){
			let mod = i/20;
			let dscl = 1+scl*mod;
			ObjRender_SetAlpha(obj, 255-255*mod);
			ObjRender_SetScaleXYZ(obj, dscl, dscl, 0);
			yield;
		}
		Obj_Delete(obj);
		count--;
	}

}

	
function CreateBackgroundImageA1(image, rect, pri, scale){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestCenter(BG2PropObj);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}
function CreateBackgroundImageB1(image, rect, pri, scale, left, top, right, bottom){
	let BG2PropObj = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjRender_SetBlendType(BG2PropObj, BLEND_ALPHA);
	ObjRender_SetAlpha(BG2PropObj, 0);
	Obj_SetRenderPriority(BG2PropObj, pri);
	ObjPrim_SetTexture(BG2PropObj, image);
	ObjSprite2D_SetSourceRect(BG2PropObj, 0, 0, rect, rect);
	ObjSprite2D_SetDestRect(BG2PropObj, left, top, right, bottom);
	ObjRender_SetScaleXYZ(BG2PropObj, scale, scale, 1);
	return BG2PropObj;
}

function GetDistance(x1,y1,x2,y2){
	return(((x2-x1)^2+(y2-y1)^2)^(1/2))
}

function AngleToLocation(x1, y1, x2, y2){
	return atan2(y2 - y1, x2 - x1);
}


function GetPreviousDirectoryA1(str, depth){
	depth = max(0, depth-1);
	descent(i in 0..length(str)){
		if(str[i-1..i] == "/"){
			if(depth == 0){
				return str[0..i];
			}else{
				depth--;
			}
		}
	}
	RaiseError("GetPreviousDirectoryA1 received an invalid path for the string.");
}
