#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Nonspell2"]
#text["Nonspell2"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let Deepsea = GetCurrentScriptDirectory ~ "Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "Deepnessseaweed.png";
let timer = 180;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	SetInvincibility(Boss, 180, 70, 56);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 240) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 949) {timer = 350;}
	if (timer == 350) {pt1;}
	if (timer == 580) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(0,60),60,8,8,8,5);}
	if (timer == 650) {pt2;}
	if (timer == 880) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(0,60),60,8,8,8,5);}
	
	yield;
	
}

@Finalize {

}


task mainTask {
	spam;
}


task pt1 {
	let dir = 360;
	ascent(i in 0..45){
		ascent(j in 0..5){
			let shot = CreateCollisionShotA1(BossX+(170-i)*cos(dir+(i*10)),BossY-(i*2)*cos(dir*2),1+(j*0.2),(dir*5)+170+(j*7),19,20);
			}
		dir-=360/90;
		PlaySoundB1("se_tan00", 45);
		wait(1);
	}
}

task pt2 {
	let dir = 180;
	ascent(i in 0..45){
		ascent(j in 0..5){
			let shot = CreateCollisionShotA1(BossX+(170-i)*cos(dir+(i*10)),BossY-(i*2)*cos(dir*2),1+(j*0.2),(-dir*5)-170+(-j*7),19,20);
			}
		dir-=360/90;
		PlaySoundB1("se_tan00", 45);
		wait(1);
	}
}

task spam {
	wait(550);
	loop{
		let ang = GetAngleToPlayer(Boss);
		loop(30){
			let variety = GetRand(-70,70);
			let offset = GetRand(-20,20);
			ascent(u in 0..3){
				CreateCollisionShotA2(BossX+offset,BossY+offset,8,ang+variety,-0.5-(u*0.04),1+(u*0.5),53,10);
			}
			PlaySoundB1("se_tan01", 50);
		wait(7);
		}
	}
}


task Ooh{
	let ang = GetAngleToPlayer(Boss);
	let lines = 7;
	let spread = 170;
	ascent(i in 0..91){
		ascent(j in 0..lines){
			let newangle = ang - spread/2 + spread/(lines-1)*j;
			CreateCollisionShotA2(BossX+20*cos(newangle+i*10),BossY+20*sin(newangle+i*10),8,newangle+1,-0.4,0.4+(i*0.03),50,10);
			CreateCollisionShotA2(BossX+20*cos(newangle-i*10),BossY+20*sin(newangle-i*10),8,newangle-1,-0.4,0.4+(i*0.03),50,10);
		}
		wait(2);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}