#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Nonspell3"]
#text["Nonspell3"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let Deepsea = GetCurrentScriptDirectory ~ "Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "Deepnessseaweed.png";
let timer = -40;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 180, 70, 56);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 10) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 800) {timer = 400;}
	if (timer == 200) {pt1;}
	if (timer == 300) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(0,60),60,3,6,8,3); pt2;}
	if (timer == 400) {pt2;}
	if (timer == 500) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(0,60),60,3,6,8,3); pt1;}
	if (timer == 600) {pt1;}
	if (timer == 700) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(0,60),60,3,6,8,3); pt2;}
	
	yield;
	
}

@Finalize {

}


task mainTask {
	spam;
}

task pt1{
	let dir = rand(0,360);
	loop(12){
		let spread = 0;
		ascent(i in 0..5) {
			CreateCollisionShotA1(BossX+20*cos(dir+spread),BossY+20*sin(dir+spread),2.6-(i*0.4),dir+spread,22,5);
			if (i > 0) {CreateCollisionShotA1(BossX+20*cos(dir+spread),BossY+20*sin(dir+spread),2.6-(i*0.4),dir-spread,22,5);}
			spread+=3;
			wait(1);
		}
	PlaySoundB1("se_tan00", 45);
	dir+=360/12;
	}
}

task pt2{
	let dir = rand(0,360);
	loop(12){
		let spread = 0;
		ascent(i in 0..5) {
			CreateCollisionShotA1(BossX+20*cos(dir+spread),BossY+20*sin(dir+spread),2.6-(i*0.4),dir+spread,22,5);
			if (i > 0) {CreateCollisionShotA1(BossX+20*cos(dir+spread),BossY+20*sin(dir+spread),2.6-(i*0.4),dir-spread,22,5);}
			spread+=3;
			wait(1);
		}
	PlaySoundB1("se_tan00", 45);
	dir-=360/12;
	}
}

task spam{
	wait(160);
	loop{
		let ang = GetAngleToPlayer(Boss);
		let shot = CreateCollisionShotA1(BossX+rand(-20,20),BossY+rand(-20,20),1,ang+rand(-50,50),52,10);
		ObjMove_AddPatternA3(shot,30,1,NO_CHANGE,0.05,rand(-1,1),3,52);
		ObjMove_AddPatternA3(shot,70,3,NO_CHANGE,-0.05,0,1,52);
		PlaySoundB1("se_tan01", 40);
		wait(4); //4
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}