#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Nonspell4"]
#text["Nonspell4"]
#System["./../../../ds_system/S_System.txt"]

#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let imgSigil = GetCurrentScriptDirectory ~ "sigil2.png";


#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 180, 100, 80);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(2500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(40);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	
	yield;
	
}

@Finalize {

}


task mainTask {
	wait(60);
	ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);
	wait(50);
	NotifyEventAll(EV_SIGIL_ON, 0);
	PlaySoundB1("se_boon01",60);
	wait(60);
	pt1;
	pt2;
}

task pt1{
	let dir = 0;
	let fluxstart = rand(0,360);
	let count = 0;
	let flux = 90*sin(count+fluxstart);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
	loop(14){
		ascent(i in 0..3){
			CreateCollisionShotA1(BossX+90*cos(dir),(BossY-60)+90*sin(dir),3.3-(i*0.7),dir+flux,15+i,20);
		}
		dir+=360/14;
	}
	PlaySoundB1("se_tan00", 45);
	count+=20.5;
	flux = 90*sin(count+fluxstart);
	wait(15);
	}
}

task pt2{
	wait(90);
	let count = 0;
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0) {
		if (count%2 == 0) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-100,100),60,3,6,6,3);}
		count++;
		if (count == 10) { count = 0;}
		wait(50);
		let dir = GetAngleToPlayer(Boss);
		loop(22){
			CreateCollisionShotA2(BossX,BossY,6,dir,-0.2,2,232,20);
			dir+=360/22;
		}
		PlaySoundB1("c_shot3", 80);
		wait(10);
		dir+=360/22/2;
		loop(22){
			CreateCollisionShotA2(BossX,BossY,6,dir,-0.2,2,232,20);
			dir+=360/22;
		}
		PlaySoundB1("c_shot3", 80);
		wait(40);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	NotifyEventAll(EV_SIGIL_OFF, 0);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);	
	CloseScript(GetOwnScriptID());
}