

#ScriptVersion[3]
#Background["./../../Stage/Stage Cirno/Misty Lake BG.h"]
#System["./../../../ds_system/S_System.txt"]


#include"./../../../ds_system/PluralFunctions.h"

let current = GetCurrentScriptDirectory;
let imgSigil = current ~ "sigil2.png";

let EV_SIGIL_ON = EV_USER+144;
let EV_SIGIL_OFF = EV_USER+143;
let RunningCondition = false;

let EnemyX = 0;
let EnemyY = 0;

let WakaLayer = 1;
let PlayLayer = 1;

@Initialize{
	PluralTask;
}

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_SIGIL_ON){
		if(!RunningCondition){
			RunningCondition = true; 
			BossSigil;
		}
	}
	case(EV_SIGIL_OFF){RunningCondition = false;}
}

@MainLoop{
	
	WakaLayer = GetCommonData("WakaLayer", 1);
	PlayLayer = GetCommonData("LocalLayer", 1);
	yield;
}

@Finalize{
}


task PluralTask{
	let obj = ObjEnemyBossScene_Create;
	
	
	if(!IsReplay){
		if(!SaveCommonDataAreaToReplayFile("ScriptBuilderData")){RaiseError("Error saving replay data.[r]Try deleting the /data folder.");}
	}else{
		if(!LoadCommonDataAreaFromReplayFile("ScriptBuilderData")){RaiseError("Error loading replay data.[r]This replay is corrupted.");}
	}
	
	// let cust = GetAreaCommonData("ScriptBuilderData", "SSP_FinalBuild", [""]);
	// if(cust[0]==""){RaiseError("Spell Practice Data not loaded correctly");}
	
	// ascent(i in 0..length(cust)){
		// let Scripts = GetScriptPathList(cust[i], TYPE_SCRIPT_SINGLE);
		
		// ObjEnemyBossScene_AddB1(obj, i, Scripts[0], [224, 224, 224]);
		// ascent(x in 1..length(Scripts)){
			// let mod = 0.4+0.6/x;
			// ObjEnemyBossScene_AddB1(obj, i, Scripts[x], [255*mod, 144*mod, 144*mod]);
		// }
	// }
	
	let userlives = GetAreaCommonData("GlobalVariables", "UserLives", 2);
	let userbombs = GetAreaCommonData("GlobalVariables", "UserBombs", 2);
	if(userlives == -1){SetPlayerLife(2);}else{SetPlayerLife(userlives);}
	if(userbombs != -1){SetPlayerSpell(userbombs);}
	
	let script = GetAreaCommonData("ScriptBuilderData", "MG_StartBossPath", "");
	if(script==""){RaiseError("Data not loaded correctly");}
	ObjEnemyBossScene_AddB2(obj, 0, script, 255, 255, 255);
	
	ObjEnemyBossScene_LoadInThread(obj);
	loop(80){yield;}
	ObjEnemyBossScene_Regist(obj);
	
	while(!Obj_IsDeleted(obj)){
		if(length(GetEnemyBossObjectID) > 0){
			let boss = GetEnemyBossObjectID[0];
			if(boss != ID_INVALID){
				EnemyX = ObjMove_GetX(boss);
				EnemyY = ObjMove_GetY(boss);
			}
		}
		yield;
	}
	loop(180){yield;}
	yield;
	//CloseScript(GetOwnScriptID);
	CloseStgScene;
}

task BossSigil{
	let Aquaring = ObjPrim_Create(OBJ_SPRITE_2D);
	let Weedring = ObjPrim_Create(OBJ_SPRITE_2D);
	let Back = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(Aquaring,imgSigil);
	ObjPrim_SetTexture(Weedring,imgSigil);
	ObjPrim_SetTexture(Back,imgSigil);
	Obj_SetRenderPriorityI(Aquaring,31);
	Obj_SetRenderPriorityI(Weedring,31);
	Obj_SetRenderPriorityI(Back,30);
	ObjSprite2D_SetSourceRect(Aquaring,0,257,256,512);
	ObjSprite2D_SetSourceRect(Weedring,257,257,512,512);
	ObjSprite2D_SetSourceRect(Back,0,1,512,255);
	ObjSprite2D_SetDestCenter(Aquaring);
	ObjSprite2D_SetDestCenter(Weedring);
	ObjSprite2D_SetDestCenter(Back);
	ObjShader_SetShaderF(Back, GetCurrentScriptDirectory~"../../../ds_system/shader/warp.hlsl");
	ObjShader_SetTechnique(Back, "TecMain");
	ObjShader_SetFloat(Back, "p_int", 0.015);
	BackAni(Back);
	RingAni(Weedring,-1,1);
	RingAni(Aquaring,2,1);
	
	task BackAni(obj){
		ObjRender_SetPosition(obj,EnemyX,EnemyY,0);
		ObjRender_SetScaleXYZ(obj,0,1,0);
		ascent(i in 0..50){
			ObjRender_SetPosition(obj,EnemyX,EnemyY,0);
			ObjRender_SetScaleXYZ(obj,i/50,0.5+i/100,0);
			yield;
		}
		let count = 0;
		let flux = 0;
		while(RunningCondition){
			ObjRender_SetPosition(obj,EnemyX,EnemyY,0);
			ObjRender_SetScaleXYZ(obj,1+(flux*0.1),1,0);
			count++;
			flux = 1*sin(count);
			if (count == 360) {count = 0;}
			ObjShader_SetFloat(Back, "p_frame", count);
			
			if(WakaLayer != PlayLayer){
				ObjRender_SetColor(Back, 128, 128, 192);
			}else{ObjRender_SetColor(Back, 255, 255, 255);}
			
			yield;
		}
		descent(i in 0..25){
			ObjRender_SetScaleXYZ(obj, i/25,0.5+i/50, 0);
			yield;
		}
		Obj_Delete(obj);
	}
	task RingAni(obj,way,glow){
		let count = 0;
		if (glow == 1) {ObjRender_SetBlendType(obj,BLEND_ADD_ARGB); ObjRender_SetColor(obj, 128, 128, 128);}
		ObjRender_SetScaleXYZ(obj,0.8,0.8,0);
		ObjRender_SetPosition(obj,EnemyX,EnemyY-60,0);
		ObjRender_SetAlpha(obj,0);
		ascent(i in 0..50){
			ObjRender_SetAlpha(obj,count);
			count+=255/50;
			ObjRender_SetAngleZ(obj,(-50*way)+(i*way));
			yield;
		}
		count = 0;
		while(RunningCondition){
			ObjRender_SetPosition(obj,EnemyX,EnemyY-60,0);
			count+=way;
			ObjRender_SetAngleZ(obj,count);
			if (count == 360*way) {count = 0;}
			if(WakaLayer != PlayLayer){
				ObjRender_SetColor(obj, 128, 128, 192);
				ObjRender_SetAlpha(obj, 160);
			}else{
				ObjRender_SetColor(obj, 255, 255, 255);
				ObjRender_SetAlpha(obj, 255);
			}
			yield;
		}
		descent(i in 0..25){
			ObjRender_SetAlpha(obj, 255/24*i);
			yield;
		}
		Obj_Delete(obj);
	}
}


