#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Spell1"]
#Text["Spell1"]
#System["./../../../ds_system/S_System.txt"]
#Background["./Background.h"]
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let imgSplash = GetCurrentScriptDirectory ~ "Splash.png";
let timer = 0;
let start = 0;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 280, 60, 12);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(60);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	if(!ObjAnim_IsAttackPlaying(Boss)){
		ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
		ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	}
	
	timer++;
	if (timer == 500) {timer = 0;}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3(, GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4("Tidal Wave \"Sea Serpent's Wake\"", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"15.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
	//movement;
	//splash;
	BossActions;
}

task BossActions{
	wait(128);
	ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2,-60,5,4);
	wait(65);
	
	loop{	
		MovementSplash;
		wait(30);
		FireWakaA1(GetAngleToPlayer(Boss));
		wait(50);
		FireWakaA1(GetAngleToPlayer(Boss));
		wait(50);
		ObjAnim_SetAttackA1(Boss, false);
	}
}

function MovementSplash{
	WriteLog(ObjMove_GetSpeed(Boss));
	WriteLog(ObjMove_GetAngle(Boss));
	let X = 0;
	ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);
	if (start == 0) {X = GetStgFrameWidth/2;}
	if (start > 0) {X = GetRandomXValue;}
	let lcount = 0;
	ObjMove_SetPosition(Boss, X, -60);
	ObjMove_SetSpeed(Boss, 0);
	ObjMove_SetAcceleration(Boss, 0);
	
	//original length: 410
	// ObjMove_AddPatternA2(Boss, 0, 0, 90, 0, 0, 0);
	// yield;
	ObjMove_AddPatternA2(Boss, 30, 0.3, 90, 13/307/2, 0, 10);
	ObjMove_AddPatternA2(Boss, 155, NO_CHANGE, NO_CHANGE, -0.035, 0, 0);
	WP(Boss,220);
	ObjAnim_SetAttackB2(Boss, 225, true);
	ObjMove_AddPatternA2(Boss, 230, NO_CHANGE, NO_CHANGE, 0.08, 0, 8);
	let dir = 270;
	ascent(i in 0..207){		
		// WriteLog(ObjMove_GetSpeed(Boss));
		if(i%4 == 0){
			
			let flux = 1+1*sin((i/8)*63);
			if (!CheckOutsideScreenA1(Boss, 0)){
					let shot = CreateCollisionShotA1(BossX,BossY,1.1+(flux*0.4),dir,19,120);
					ReflectColorchange(shot,2,18);
					Obj_SetRenderPriorityI(shot,52);
					shot = CreateCollisionShotA1(BossX,BossY,1.1+(flux*0.4),-dir-180,19,120);
					ReflectColorchange(shot,2,18);
					Obj_SetRenderPriorityI(shot,52);
				
			}
			PlaySoundB1("se_tan01", 50);
			dir+=3;
		}
		
		
		wait(1);
	}
	wait(100);
	if (start == 0) {start++;}
	
	ImpactVert(GetStgFrameHeight,0);
	ObjMove_SetAcceleration(Boss, 0);
	ObjMove_SetSpeed(Boss, 0);
}

function FireWakaA1(ang){
	ObjAnim_SetAttackA1(Boss, true);
	let ex = ObjMove_GetX(Boss);
	let ey = ObjMove_GetY(Boss);
	let count = rand(0,360);
	
	// let dist = GetDistance(ex, ey, tx, ty);
	let dist = 0;
	
	let spd = 0.15;
	let mspd = 6.6;
	
	let mx = cos(ang);
	let my = sin(ang);
	ObjMove_SetAngle(Boss, ang);
	
	let scount = 0;
	
	let backup = 0;
	
	while(CheckOutsideScreenA1(Boss, 0)){
		backup++;
		if(backup > 300){break;}
		DoStuff;
	}
	
	while(!CheckOutsideScreenA1(Boss, 72)){
		DoStuff;
	}
	
	function DoStuff{
		dist = ex+ey;
		ObjMove_SetPosition(Boss, ex, ey);
		
		spd = min(spd + 0.02+spd*0.02, mspd);
		ex+=spd*mx;
		ey+=spd*my;
		scount++;
		
		
		count++; 
		let flux = 1+2*sin(count*12); 
		if(scount >= 4){
			ascent(i in 0..2){
				let a = CreateCollisionShotA1(ex, ey, 1+(flux*0.4), ang+90+180*i, 115, 140); //Remove J to make only two shots again
				//Obj_SetRenderPriorityI(a,49);
				// if (bounce == true) {ReflectColorchange(a,1,114);}
			}
			SplashA1(Boss);
			scount = 0;
		}
		PlaySoundB1("se_tan00", 50);
		yield;
	}
	let x = ObjMove_GetX(Boss);
	let y = ObjMove_GetY(Boss);
	
	if(y < -60){ImpactVert(0,1);}
	else if(y > GetStgFrameHeight+60){ImpactVert(GetStgFrameHeight,0);}
	else if(x < -60){ImpactHor(0,1);}
	else if(x > GetStgFrameWidth+60){ImpactHor(GetStgFrameWidth,0);}
}

task CreateSwishingShotA1(x, y, spd, ang, graph, delay, rate){

	// let z = CreateShotA1(x, y, spd, rand(80, 100), graph, delay);
	
	// ObjShot_SetDeleteFrame(z, 45);
	
	
	// while(!Obj_IsDeleted(z)){
		// x = ObjMove_GetX(z);
		// y = ObjMove_GetY(z);
		// yield;
	// }
	// if(Obj_IsDeleted(z)){return;}
	
	// spd = spd*0.5;
	let a = CreateCollisionShotA1(x, y, spd, ang, graph, delay);
	
	loop(delay){yield;}
	
	let s = round(rand(-25, 25));
	
	while(!Obj_IsDeleted(a)){
		let ts = spd*sin(s);
		
		s+=rate;
		
		if(ts < 0){
			s+=rate*0.5;
			ObjMove_SetSpeed(a, (ts));
		}else{
			ObjMove_SetSpeed(a, ts);
		}
		yield;
	}

}


task splash{
	let count = rand(0,360);
	loop(67){
		let dir = 0;
		let speed = rand(0.4,0.8);
		count++;
		let flux = 1+2*sin(count*21);
		if (!CheckOutsideScreenA1(Boss, 0)) {loop(2){
				let shot = CreateCollisionShotA1(BossX,BossY,0.5+speed+(flux*0.4),dir,129,12);
				ReflectColorchange(shot,2,128);
				dir+=180;
			}
		}
		PlaySoundB1("se_tan01", 50);
		wait(6);
	}
	ImpactVert(GetStgFrameHeight,0);
}

task movement{
	let count = 0;
	let X = 0;
	if (start == 0) {X = GetStgFrameWidth/2;}
	if (start > 0) {X = GetRandomXValue;}
	loop(410){
		ObjMove_SetPosition(Boss,X,-60+(count*count*0.0035));
		count++;
		yield;
	}
	if (start == 0) {start++;}
}

task ReflectColorchange(obj,amt,color) {
	ascent(i in 0..amt){
	while (ObjMove_GetX(obj)>0&&ObjMove_GetX(obj)<GetStgFrameWidth&&ObjMove_GetY(obj)>0&&ObjMove_GetY(obj)<GetStgFrameHeight) {yield;}
	if (ObjMove_GetX(obj)<=0) {
			ObjMove_SetX(obj,0);
			ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
			ObjShot_SetGraphic(obj,color-i);
			PlaySoundB1("se_kira00", 60);
		}
	else if (ObjMove_GetX(obj)>=GetStgFrameWidth) {
			ObjMove_SetX(obj,GetStgFrameWidth);
			ObjMove_SetAngle(obj,180-ObjMove_GetAngle(obj));
			ObjShot_SetGraphic(obj,color-i);
			PlaySoundB1("se_kira00", 60);
		}
    else if (ObjMove_GetY(obj)<=0) {
            ObjMove_SetY(obj,0);
            ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
			ObjShot_SetGraphic(obj,color-i);
			PlaySoundB1("se_kira00", 60);
                }
    else if (ObjMove_GetY(obj)>=GetStgFrameHeight) {
            ObjMove_SetY(obj,GetStgFrameHeight);
            ObjMove_SetAngle(obj,0-ObjMove_GetAngle(obj));
			ObjShot_SetGraphic(obj,color-i);
			PlaySoundB1("se_kira00", 60);
                }
	wait(1);
	}
}

function GetRandomXValue{
 return GetStgFrameWidth/4*round(rand(0.5, 3.5))
}

task ImpactHor(side,way){
	
	PlaySoundB1("se_don00", 60);
	let argi = 19;
	let div = GetStgFrameHeight/(argi-1);
	let count = 90;
	let flux = 0;
	let rc = round(max(0, (GetStgFrameHeight-BossY)/div));
	let lc = argi-rc;
	
	let ry = max(0, min(GetStgFrameHeight, BossY));
	
	let bspd = 0.8;
	let sspd = 1.9;
	ascent(i in 0..lc){
		flux = 2+2*sin(count);
		ascent(J in -1..1){
			CreateCollisionShotA2(side,BossY-div*i,2+(flux*0.5)+(J*0.1),180-(180*way),-0.1-(flux*0.001),0.5+(flux*0.3)+(J*0.1),67,40);
			}
		count+=180/lc;
		//WriteLog(count);
	}
	count = 90;
	flux = 0;
	ascent(i in 1..rc+1){
		flux = 2+2*sin(count);
		ascent(J in -1..1){
			CreateCollisionShotA2(side,BossY+div*i,2+(flux*0.5)+(J*0.1),180-(180*way),-0.1-(flux*0.001),0.5+(flux*0.3)+(J*0.1),67,40);
		}
		count+=180/rc;
	}
	
	
	// loop(19){
		// let flux = 1+2*sin(Y+BY);
		// CreateShotA2(side,Y,0.4+(flux*0.2),180-(180*way),0.02+(flux*0.01),1+(flux*0.2),67,20);
		// Y+=GetStgFrameHeight/18;
	// }
}

task ImpactVert(side,way){
	PlaySoundB1("se_don00", 60);
	let X = 0;
	let BX = ObjMove_GetX(Boss);
	
	let count = 90;
	let flux = 0;
	
	let argi = 15;
	let div = GetStgFrameWidth/(argi-1);
	
	let rc = round(max(0, (GetStgFrameWidth-BossX)/div));
	let lc = argi-rc;
	
	let rx = max(0, min(GetStgFrameWidth, BossX));
	
	let bspd = 0.8;
	let sspd = 1.9;
	ascent(i in 0..lc){
		flux = 2+2*sin(count);
		ascent(J in -1..1){
			CreateCollisionShotA2(rx-div*i,side,2+(flux*0.5)+(J*0.1),270-(180*way),-0.1-(flux*0.001),0.5+(flux*0.3)+(J*0.1),67,40);
			}
		count+=180/lc;
	}
	count = 90;
	flux = 0;
	ascent(i in 1..rc+1){
		flux = 2+2*sin(count);
		ascent(J in -1..1){
			CreateCollisionShotA2(rx+div*i,side,2+(flux*0.5)+(J*0.1),270-(180*way),-0.1-(flux*0.001),0.5+(flux*0.3)+(J*0.1),67,40);
			}
		count+=180/rc;
	}
}

task SplashA1(obj){
	let img = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(img,imgSplash);
	let op = 0;
	let size = 0;
	let hi = 0;
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	ObjSprite2D_SetSourceRect(img,0,0,64,64);
	ObjSprite2D_SetDestCenter(img);
	Obj_SetRenderPriorityI(img,55);
	ObjRender_SetAlpha(img,op);
	ObjRender_SetPosition(img,X,Y,0);
	PlaySoundB1("se_water",60);
	loop(5){
		ObjRender_SetAlpha(img,op);
		ObjRender_SetScaleXYZ(img,size,size,0);
		ObjRender_SetPosition(img,X,Y-hi,0);
		op+=255/5;
		size+=1.2/5;
		hi+=1.2;
		yield;
	}
	loop(10){
		ObjRender_SetAlpha(img,op);
		ObjRender_SetScaleXYZ(img,size,size,0);
		ObjRender_SetPosition(img,X,Y-hi,0);
		op-=255/10;
		size+=1.2/10;
		hi+=1.2;
		yield;
	}
	Obj_Delete(img);
}

task WP(obj,ti){
	wait(ti);
	SplashA1(obj);
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}