#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Spell2"]
#Text["Spell2"]
#System["./../../../ds_system/S_System.txt"]
#Background["./Background.h"]
#include"./../../../ds_system/SpellFunctions.h"

#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let timer = -30;
#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 180, 16, 12);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/2.5,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(80);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 900) {timer = 100;}
	if (timer == 60) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 151) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-80,80),50,6,6,10,1);}
	if (timer == 301) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,120),GetStgFrameHeight/3+rand(-80,80),50,6,6,10,1);}
	if (timer == 451) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-80,80),50,6,6,10,1);}
	if (timer == 601) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-80,80),50,6,6,10,1);}
	if (timer == 751) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-120,120),GetStgFrameHeight/3+rand(-80,80),50,6,6,10,1);}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3("Beauty Sign \"Drifting Sakura Blossom\" ", GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4("Beauty Sign \"Drifting Sakura Blossom\"", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"15.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
	wait(169);
	petalaiming;
	loop{
		PetalsRipple;
		wait(140);
		PetalsRipple;
		wait(140);
	}
}

task petalaiming{
	wait(240);
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0){
		PetalsAim(1);
		wait(360);
		PetalsAim(-1);
		wait(360);
	}
		
	task PetalsAim(way){
		let side = 0;
		if (way == 1) {side = 0};
		if (way == -1) {side = 1};
		let x = (10*way)+(GetStgFrameWidth*side);
		loop(15){
			PlaySoundB1("se_kira01", 60);
			let y = rand(10,140);
			let dir = atan2(GetPlayerY-y,GetPlayerX-x)-(360/5*2);
			ascent(i in -2..3){
				let shot = CreateFadeInShotA1(x+10*cos(dir),y+10*sin(dir),0.5,dir,131,30);
				ObjMove_AddPatternA2(shot,45,0.5,NO_CHANGE,0.1,-i*2,1.5); // was 3 max speed
				ObjMove_AddPatternA2(shot,85,NO_CHANGE,NO_CHANGE,0.05,0,1.5); //85 for better aim
				dir+=360/5;
			}
			wait(10);
			x+=(GetStgFrameWidth-10)/15*way;
		}
	}

}

task PetalsRipple{
	let dir = rand(0,360);
	let lx = rand(50,GetStgFrameWidth-50);
	let ly = rand(40,60);
	let way = rand(-1,1);
	let lead = CreateFadeInShotA1(lx,ly,1,90,1,80);
	ObjMove_AddPatternA2(lead,0,1,90,1,rand(-1,1),1);
	ObjMove_AddPatternA2(lead,80,0,90,0.01,0,1);
	PlaySoundB1("se_option", 60);
	loop(5){
		Petal(lead,dir,120,way);
		Petal(lead,dir+360/5/2,130,way);
		dir+=360/5;
	}
	wait(80);
	lx = ObjMove_GetX(lead);
	ly = ObjMove_GetY(lead);
	dir = 90;
	if (lx == 0) {return;}
	PlaySoundB1("se_tan02", 50);
	ascent(j in 0..3){
		ascent(i in 0..25){
			let shot = CreateCollisionShotA1(lx+30*cos(dir),ly+30*sin(dir),0.6+(j*0.4),dir,18,20);
			ObjRender_SetBlendType(shot,BLEND_ADD_ARGB);
			dir+=360/25;
		}
		dir+=360/25/2;
	}
	
	task Petal(obj,dir,graphic,way){
		let x = ObjMove_GetX(obj);
		let y = ObjMove_GetY(obj);
		let rot = dir;
		let petl = CreateFadeInShotA1(x+20*cos(rot),y+20*sin(rot),0,dir,graphic,80);
		while (ObjMove_GetY(obj) < GetStgFrameHeight){
			x = ObjMove_GetX(obj);
			y = ObjMove_GetY(obj);
			ObjMove_SetPosition(petl,x+20*cos(rot),y+20*sin(rot));
			ObjMove_SetAngle(petl,rot);
			rot+=way;
			if (Obj_IsDeleted(obj)) {Obj_Delete(petl); break;}
		yield;
		}
		PlaySoundB1("se_kira00", 60);
		ObjMove_AddPatternA2(petl,0,0,NO_CHANGE,0.05,0,1.5);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}


function CreateFadeInShotA1(x, y, spd, ang, graph, delay){

	
	let objShot = ObjShot_Create(OBJ_SHOT);
	
	ObjShot_SetIntersectionEnable(objShot, false);
	Obj_SetValue(objShot, "g_Coll", false);
	
	
	DoShotStuff;
	return objShot;

	task DoShotStuff{
		ObjShot_Regist(objShot);
		ObjMove_SetPosition(objShot, x, y);
		ObjMove_SetAngle(objShot, ang);
		ObjShot_SetGraphic(objShot, graph);
		
		ObjShot_SetIntersectionEnable(objShot, false);
		let i = 0;
		while(i<delay&&!Obj_IsDeleted(objShot)){
			let alpf = i*(225/delay);
			let scl = (delay-i)*(1.75/delay);
			ObjRender_SetScaleXYZ(objShot, scl+1, scl+1, 1);
			ObjRender_SetAlpha(objShot, min(255, alpf-35));
			i+=1/TimeSpeed;
			yield;
		}
		ObjShot_SetIntersectionEnable(objShot, true);
		ObjRender_SetScaleXYZ(objShot, 1, 1, 1);
		ObjRender_SetAlpha(objShot, 255);
		ObjMove_SetSpeed(objShot, spd);
	}
}

