#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Spell3"]
#Text["Siren's Song \"Watery Grave Beckoning\" "]
#Background["./Background.h"]
#System["./../../../ds_system/S_System.txt"]


#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let Deepsea = GetCurrentScriptDirectory ~ "Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "Deepnessseaweed.png";
let timer = -100;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 380, 16, 12);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(80);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 1599) {timer = 400;}
	if (timer == 0) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 91) {WaveCrash(rand(0,-20),40,10);}
	if (timer == 191) {WaveCrash2(GetStgFrameWidth+rand(0,20),40,10);}
	if (timer == 401) {Song(270,1);}
	if (timer == 501) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 561) {WaveCrash(rand(0,-20),40,10);}
	if (timer == 601) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 701) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 761) {WaveCrash2(GetStgFrameWidth+rand(0,20),40,10);}
	if (timer == 901) {Song(271,-1);}
	if (timer == 961) {WaveCrash(rand(0,-20),40,10);}
	if (timer == 1001) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 1101) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 1161) {WaveCrash2(GetStgFrameWidth+rand(0,20),40,10);}
	if (timer == 1201) {ObjMove_SetDestAtWeightLimitedA1(Boss,GetStgFrameWidth/2+rand(-90,90),GetStgFrameHeight/3+rand(-40,40),50,8,8,20,18);}
	if (timer == 1320) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 1400) {DoubleWave(40,10);}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3("Siren Song \"Watery Grave Beckoning\" ", GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4("Siren Song \"Watery Grave Beckoning\"", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
}

task Song(color,way){
	let dir = rand(0,360);
	ascent(i in 1..17){
		loop(20){
			let note = CreateCollisionShotA1(BossX,BossY,2-(i*0.05),dir,color,20);
			ObjMove_AddPatternA2(note,0,NO_CHANGE,NO_CHANGE,0,(i*0.15)*way,0);
			ObjMove_AddPatternA2(note,50,NO_CHANGE,NO_CHANGE,0,(i*0.015)*way,0);
			if(i%2 == 0){
			note = CreateCollisionShotA1(BossX,BossY,2-(i*0.05),dir,272,20);
			ObjMove_AddPatternA2(note,20,NO_CHANGE,NO_CHANGE,0,-(i*0.15)*way,0);
			ObjMove_AddPatternA2(note,100,NO_CHANGE,NO_CHANGE,0,-(i*0.015)*way,0);
			}
			dir+=360/20;
		}
	PlaySoundB1("se_lgods3", 60);
	if(i%2 == 0){PlaySoundB1("se_lgods2", 60);}
	dir+=2*way;
	wait(20);
	}
}

task WaveCrash(side,amt,time){
	PlaySoundB1("se_don00", 80);
	let col = 3;
	let wash;
	ascent(u in 0..amt){
	if (u == 0) {col = 3} 
	if (u == 2) {col = -2} 
	if (u == 4) {col = -1} 
	if (u == 8) {col = 0} 
	ascent(i in 0..(GetStgFrameHeight/30-u/2)){
		wash = CreateShotB2(side,GetStgFrameHeight-i*31,1+(i*0.2),-(i*0.1),-0.03,0.035,0,4+(i*0.02),232+col,10);
		GiveCollision(wash);
	}
	PlaySoundB1("se_tan02", 70-u);
	wait(time);
	}
}

task WaveCrash2(side,amt,time){
	PlaySoundB1("se_don00", 80);
	let col = 3;
	let wash;
	ascent(u in 0..amt){
	if (u == 0) {col = 3} 
	if (u == 2) {col = -2} 
	if (u == 4) {col = -1} 
	if (u == 8) {col = 0} 
	ascent(i in 0..(GetStgFrameHeight/30-u/2)){
		wash = CreateShotB2(side,GetStgFrameHeight-i*31,-1-(i*0.2),-(i*0.1),0.03,0.035,0,4+(i*0.02),232+col,10);
		GiveCollision(wash);
	}
	PlaySoundB1("se_tan02", 70-u);
	wait(time);
	}
}

task DoubleWave(amt,time){
	let col = 3;
	let wash;
	ascent(u in 0..amt){
	if (u == 0) {col = 3} 
	if (u == 2) {col = -2} 
	if (u == 4) {col = -1} 
	if (u == 8) {col = 0} 
	ascent(i in 0..(GetStgFrameHeight/34-u/2)){
		wash = CreateShotB2(0,GetStgFrameHeight-i*35,1+(i*0.2),-(i*0.25),-0.003,0.035,0,4+(i*0.02),52+col,10);
		GiveCollision(wash);
		wash = CreateShotB2(GetStgFrameWidth,GetStgFrameHeight-i*35,-1-(i*0.2),-(i*0.25),0.003,0.035,0,4+(i*0.02),52+col,10);
		GiveCollision(wash);
	}
	PlaySoundB1("se_tan00", 70-u);
	wait(time);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}