#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Spell4"]
#Text["Entanglement \"Enchanted Kelp Forest\""]
#Background["./Background.h"]
#System["./../../../ds_system/S_System.txt"]


#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let Deepsea = GetCurrentScriptDirectory ~ "Deepness.png";
let Seaweed = GetCurrentScriptDirectory ~ "Deepnessseaweed.png";
let timer = -100;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	SetInvincibility(Boss, 260, 14, 12);
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/3,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(80);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == 1399) {timer = 400;}
	if (timer == 80) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 200) {seaweed;}
	if (timer == 425) {BreakingLaser;}
	if (timer == 625) {BreakingLaser2(-1);}
	if (timer == 680) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 800) {seaweed;}
	if (timer == 825) {BreakingLaser2(1);}
	if (timer == 1025) {BreakingLaser;}
	if (timer == 1180) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 1225) {BreakingLaser;}
	if (timer == 1300) {seaweed;}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3("Entanglement \"Enchanted Kelp Forest\" ", GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4("Entanglement \"Enchanted Kelp Forest\"", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"04.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
}

task seaweed {
	let direction = floor(rand(0,90));
	PlaySoundB1("se_laser00", 50);
	ascent(i in 0..75){
		let way = 1;
		if (i%2 == 0) {way = 0;}
		loop(8){
			if (i > 1) {let las = CreateCollisionShotA1(BossX,BossY,2.6,direction,152,0);
			ObjRender_SetBlendType(las,BLEND_ADD_ARGB);
			swerve(las,1.5,0.6,90+(180*way),30);
			
			//WriteLog(way);
			}
			direction+=360/8;
			PlaySoundB1("se_tan01", 50);
		}
		wait(4);
	}
}

task swerve(obj,amt,speed,startpoint,time){
	wait(time);
	let flux = startpoint;
	while(!Obj_IsDeleted(obj)) {
		flux+=speed;
		ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
		yield;
	}
}

task BreakingLaser{
	let dir = rand(0,360);
	loop(20){
		let las = CreateLooseLaserA1(BossX,BossY,1,dir,80,10,162,0);
		dir+=360/20;
		Lasersplode(las,10,0,48,20,0.23);
	}
	PlaySoundB1("se_laser01", 50);
}

task BreakingLaser2(way){
	let dir = rand(0,360);
	loop(10){
		let las = CreateCurveLaserA1(BossX,BossY,1,dir,80,10,160,0);
		ObjCrLaser_SetTipDecrement(las,0);
		ObjMove_SetAngularVelocity(las,0.7*way);
		dir+=360/10;
		Lasersplode(las,8,0,46,20,0.18);
	}
	PlaySoundB1("se_laser01", 50);
}

task Lasersplode(las,division,aim,graphic,delay,I){ 
	let DelX = [];
	let DelY = [];
	let DelDir = [];
	let spread = -60;
	wait(delay);
	ascent(i in 0..ObjLaser_GetLength(las)/division) {
		DelX = append(DelX,ObjMove_GetX(las));
		DelY = append(DelY,ObjMove_GetY(las));
		DelDir = append(DelDir,ObjMove_GetAngle(las));
		wait(division);
	}
		loop(2){
			ascent(i in 0..ObjLaser_GetLength(las)/division) {
				CreateCollisionShotA2(DelX[i],DelY[i],3,DelDir[i]+spread,-0.2,2-(i*I),graphic,10);	
			}
		spread+=120;
	}
	PlaySoundB1("se_kira01", 50);
	PlaySoundB1("se_tan02", 50);
	Obj_Delete(las);
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}