#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Title["Spell5"]
#Text["Spell5"]
#System["./../../../ds_system/S_System.txt"]
#Background["./Background.h"]
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

let Boss;
let BossX = 0;
let BossY = 0;
let imgBoss = GetCurrentScriptDirectory ~ "boss.png";
let effect = GetCurrentScriptDirectory ~ "DrainEffect.png";
let timer = -90;
let start = 0;
let sucker;
let expeller;

#include "./AchyShot_const.cs"

@Initialize {

	Boss = ObjEnemy_Create(OBJ_ENEMY_BOSS);
	ObjEnemy_Regist(Boss);
	
	ObjPrim_SetTexture(Boss,imgBoss);
	ObjSprite2D_SetSourceRect(Boss,0,0,110,145);
	ObjSprite2D_SetDestCenter(Boss); 
	SetEnemyAnimationA1(Boss);
	
	ObjMove_SetDestAtSpeed(Boss,GetStgFrameWidth/2,GetStgFrameHeight/2,5);
	Ending;
	mainTask;
}

@Event {

	alternative(GetEventType())
	case(EV_REQUEST_LIFE) {
		SetScriptResult(500);
	}
	case(EV_REQUEST_TIMER) {
		SetScriptResult(70);
	}

}

@MainLoop{
	BossX = ObjMove_GetX(Boss);
	BossY = ObjMove_GetY(Boss);
	
	//ObjEnemy_SetIntersectionCircleToShot(Boss,BossX,BossY,24);
	//ObjEnemy_SetIntersectionCircleToPlayer(Boss,BossX,BossY,24);
	
	timer++;
	if (timer == -10) {ConcentrationA1(Boss,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);}
	if (timer == 190) {intro(Boss);}
	if (timer == 190) {ObjMove_SetDestAtWeight(Boss,GetStgFrameWidth/2,-120,5,2);}
	if (timer == 460) {pt2(expeller);}
	if (timer == 1030) {pt1(expeller,7);}
	if (timer == 1630) {spiral(expeller);}
	if (timer == 2430) {rings(expeller);}
	if (timer == 3130) {outro(expeller);}
	yield;
	
}

@Finalize {

}


task mainTask {
	// ObjCutin_SetSpellcardM3("Revitalizing Whirlpool \"Mermaid's Secret Lagoon\" ", GetCurrentScriptDirectory~"Karen.png", "RITSUKA", 3500000, 102, 16, 64);
	
	let face = GetCurrentScriptDirectory~"face/";
	ObjCutin_SetSpellcardM4("Revitalizing Whirlpool \"Mermaid's Secret Lagoon\"", 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
	ObjCutin_SetSpellcardLayersM4([face~"10.png"]);
	
	yield;
	ObjEnemyBossScene_StartSpell(objScene);
	Orbs;
	border;
}

task Orbs{
	wait(180);
	PlaySoundB1("se_option",60);
	let dis = 0;
	let count = 180;
	let suckerBG = CreateCollisionShotA1(BossX,BossY,0,0,256,20);
	sucker = CreateCollisionShotA1(BossX,BossY,0,0,262,20);
	Obj_SetValue(sucker, "Suction", false);
	Obj_SetValue(suckerBG, "Suction", false);
	ObjShot_SetSpellResist(sucker,true);
	ObjShot_SetSpellResist(suckerBG,true);
	expeller = CreateCollisionShotA1(BossX,BossY,0,0,258,20);
	Obj_SetValue(expeller, "Suction", false);
	ObjShot_SetSpellResist(expeller,true);
	ObjRender_SetBlendType(sucker,BLEND_SUBTRACT);
	while(true) {
		if (dis < 200) {dis+=0.5;count+=0.5*(sin(dis*0.9))}
		if (dis == 20) {GrantSuctionPropertyA1(sucker, 300, 1000, 15); effects(sucker,expeller);}
		count+=0.5;
		ObjMove_SetPosition(sucker,GetStgFrameWidth/2+dis*cos(count+180),GetStgFrameHeight/2+dis*sin(count+180));
		ObjMove_SetPosition(suckerBG,GetStgFrameWidth/2+dis*cos(count+180),GetStgFrameHeight/2+dis*sin(count+180));
		ObjMove_SetPosition(expeller,GetStgFrameWidth/2+dis*cos(count),GetStgFrameHeight/2+dis*sin(count));
		yield;
	}
}

/*task PullPlayer(obj,vel){
	let x = GetPlayerX;
	let y = GetPlayerY;
	while(!Obj_IsDeleted(obj)){
		x = vel*cos(GetAngleToPlayer(obj));
		y = vel*sin(GetAngleToPlayer(obj));
		ObjMove_SetPosition(GetPlayerObjectID,GetPlayerX-x,GetPlayerY-y);
		yield;
	}
}*/

task intro(obj){
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	let dir = rand(0,360);
/* 	loop(8){
		let shot = CreateShotA2(x,y,1.4,dir,-0.001,0,72,20);
		ObjShot_SetAutoDelete(shot,false);
		waitpull(shot,40);
		dir+=360/8;
	} */
	wait(5);
	let argi = 26;
	ascent(i in 0..argi){
		let dir = i*26;
		let shot = CreateCollisionShotA1(BossX,BossY,2.5,dir,72,20);
		ObjMove_SetAcceleration(shot,-0.05);
		ObjMove_SetMaxSpeed(shot, 0.68);
		ObjShot_SetAutoDelete(shot,false);
		waitpull(shot,55);
		PlaySoundB1("se_tan00", 45);
		wait(2);
	}
	
}

task pt1(obj,numboftimes){
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	SpellBurstA1(x,y,"CHERRY",[64,255,255]);
	PlaySoundB1("se_enep02", 65);
	wait(20);
	loop(numboftimes){
		let dir = rand(0,360);
		x = ObjMove_GetX(obj);
		y = ObjMove_GetY(obj);
		loop(18){
			let shot = CreateCollisionShotA2(x,y,4,dir,-0.02,0,6,20);
			ObjShot_SetAutoDelete(shot,false);
			dir+=360/18;
			waitpull(shot,110);
		}
	PlaySoundB1("se_tan01", 55);	
	wait(60);
	}
}

task spiral(obj){
	let dir = rand(0,360);
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	SpellBurstA1(x,y,"CHERRY",[64,255,255]);
	PlaySoundB1("se_enep02", 65);
	wait(20);
	ascent(i in 0..45){
		x = ObjMove_GetX(obj);
		y = ObjMove_GetY(obj);
		loop(4){
			dir-=360/4;
			let shot = CreateCollisionShotA2(x,y,4,dir,-0.02,0,83,20);
			ObjShot_SetAutoDelete(shot,false);
			waitpull(shot,120);
		}
		PlaySoundB1("se_tan02", 65);
		wait(13);
		dir-=20;
	}
}

task rings(obj){
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	SpellBurstA1(x,y,"CHERRY",[64,255,255]);
	PlaySoundB1("se_enep02", 65);
	wait(20);
	loop(5){
		let dir = rand(0,360);
		ascent(i in 0..7){
			x = ObjMove_GetX(obj);
			y = ObjMove_GetY(obj);
			loop(7){
				let shot = CreateCollisionShotA2(x,y,3.2-(i*0.3),dir,-0.001,0,39,20);
				ObjShot_SetAutoDelete(shot,false);
			//	let shot2 = CreateShotA2(x,y,5-(i*0.2),dir+16/2,-0.02,0,94,20);
				//ObjShot_SetAutoDelete(shot2,false);
				dir+=360/7;
				waitpull(shot,200-i*12);
				//waitpull(shot2,130-i*6);
			}
		dir+=360/7/2;
		}
		PlaySoundB1("se_kira00",70);
		wait(110);
	}
}

/*task pt1(obj){
	
	loop(2){
		let dir = rand(0,360);
	loop(5){
		let x = ObjMove_GetX(obj);
		let y = ObjMove_GetY(obj);
		loop(10){
			let shot = CreateShotA2(x,y,3,dir,-0.005,0,116,20);
			ObjShot_SetAutoDelete(shot,false);
			waitpull(shot,160);
			dir+=360/10;
		}
	dir+=12;
	wait(8);
	}
	loop(5){
		let x = ObjMove_GetX(obj);
		let y = ObjMove_GetY(obj);
		loop(10){
			let shot = CreateShotA2(x,y,3,dir,-0.005,0,116,20);
			ObjShot_SetAutoDelete(shot,false);
			waitpull(shot,180);
			dir+=360/10;
		}
	dir-=6;
	wait(8);
	}
	}
}*/

task pt2(obj){
	let dir = rand(0,360);
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	SpellBurstA1(x,y,"CHERRY",[64,255,255]);
	PlaySoundB1("se_enep02", 65);
	wait(20);
	loop(4){
		x = ObjMove_GetX(obj);
		y = ObjMove_GetY(obj);
		loop(6){
			let spread = -18;
			ascent(i in 0..8){
				spread+=36/8;
				let shot = CreateCollisionShotA2(x,y,3,dir+spread,-0.01,0,237,20);
				ObjShot_SetAutoDelete(shot,false);
				waitpull(shot,180); //reduced by 20 when I added to the "ttime"
			}
			dir+=360/6;
		}
	//dir+=360/6/2;
	PlaySoundB1("c_shot3", 80);
	wait(60);
	}
}

task outro(obj){
	let ang = GetAngleToPlayer(obj);
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	SpellBurstA1(x,y,"CHERRY",[64,255,255]);
	PlaySoundB1("se_enep02", 65);
	wait(20);
	loop(60){
		x = ObjMove_GetX(obj);
		y = ObjMove_GetY(obj);
		let spread = 0;
		ascent(i in 0..6){
			let shot = CreateCollisionShotA2(x,y,2.5,ang+spread,-0.001,0,72,20);
			let shot2 = CreateCollisionShotA2(x,y,2.5,-ang+spread+5,-0.001,0,72,20);
			ObjShot_SetAutoDelete(shot,false);
			waitpull(shot,140);
			ObjShot_SetAutoDelete(shot2,false);
			waitpull(shot2,140);
			spread+=360/6;
		}
		ang+=6;
		PlaySoundB1("se_tan00", 45);
		wait(25);
	}
}

/*task C(obj) {
	while(!Obj_IsDeleted(obj)){
	let dir = GetAngleToPlayer(obj);
	let x = ObjMove_GetX(obj);
	let y = ObjMove_GetY(obj);
	let shot = CreateShotA1(x,y,1.5,dir,105,20);
	ObjShot_SetAutoDelete(shot,false);
	waitpull(shot,100);
	wait(120);
	}
}*/

task waitpull(obj,time){
	Obj_SetValue(obj, "Suction", false);
	wait(time);
	ObjMove_SetAcceleration(obj, 0);
	let ttime = 40; 
	ascent(i in 0..ttime){
		let mod = 48/ttime*i;
		if (i == 20) {PlaySoundB1("se_lgods4", 35);}
		ObjRender_SetColor(obj,255-mod, 255-mod, 255-255/ttime*i);
		yield;
	}
	Obj_SetValue(obj, "Suction", true);
	ObjRender_SetColor(obj,255,255,0);
}

task effects(obj1,obj2){

	while(true){
	pulse(obj1,obj2);
	wait(60);
	}


	task pulse(obj1,obj2){
		let count = 0;
		let count2 = 0;
		let Eft1 = ObjPrim_Create(OBJ_SPRITE_2D);
		let Eft2 = ObjPrim_Create(OBJ_SPRITE_2D);
		ObjPrim_SetTexture(Eft1,effect);
		ObjSprite2D_SetSourceRect(Eft1,80,80,160,160);
		ObjSprite2D_SetDestCenter(Eft1);
		ObjPrim_SetTexture(Eft2,effect);
		ObjSprite2D_SetSourceRect(Eft2,0,0,80,80);
		ObjSprite2D_SetDestCenter(Eft2);		
		loop(90){
			count+=7/90;
			count2+=100/90;
			ObjRender_SetPosition(Eft1,ObjMove_GetX(obj1),ObjMove_GetY(obj1),0);
			ObjRender_SetPosition(Eft2,ObjMove_GetX(obj2),ObjMove_GetY(obj2),0);
			ObjRender_SetScaleXYZ(Eft1,7-count,7-count,0);
			ObjRender_SetScaleXYZ(Eft2,count,count,0);
			ObjRender_SetAlpha(Eft1,count2);
			ObjRender_SetAlpha(Eft2,100-count2);
			yield;
		}
		Obj_Delete(Eft1);
		Obj_Delete(Eft2);
	}
}

task border{
	let dir = 0;
	wait(140);
	while(true){
		loop(6){
			let obj = CreateCollisionShotA1(GetStgFrameWidth/2+200*cos(dir),GetStgFrameHeight/2+200*sin(dir),4,dir+90,279,60);
			Obj_SetValue(obj, "Suction", false);
			obj = CreateCollisionShotA1(GetStgFrameWidth/2+200*cos(dir),GetStgFrameHeight/2+200*sin(dir),4,dir+70,279,60);
			Obj_SetValue(obj, "Suction", false);
			dir-=360/6;
		}
		dir-=3;
		wait(5);
	}
}

task Ending {
	while(ObjEnemy_GetInfo(Boss, INFO_LIFE) > 0)
	{
		yield;
	}
	EnemyDead = true;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);
	PlaySoundB1("se_tan00",100);
	Obj_Delete(Boss);
	SetAutoDeleteObject(true);
	CloseScript(GetOwnScriptID());
}