#TouhouDanmakufu[Single]
#ScriptVersion[3]
#Background["./Background.h"]
#System["./../../../ds_system/S_System.txt"]
#Title["Spell6"]
#Text["Spell6"]
#include"./../../../ds_system/SpellFunctions.h"
#include"./Animation.h"

#include "./AchyShot_const.cs"

#include"./../../../ds_system/library/Dialogue/DialogueLib.txt"

let current = GetCurrentScriptDirectory;
let face = current~"face/";
let pface = current~"pface/";
let imgSplash = GetCurrentScriptDirectory ~ "Splash.png";
let imgEnemy = current~"boss.png"; 
let BossCutIn = face~"01.png";
let imgSigil = GetCurrentScriptDirectory ~ "sigil2.png";


let MaxLayer = 1;
let LocalLayer = MaxLayer;
let TransitionTime = 35;

let Duration = GetCommonData("DiveDuration", 20);
let CurDur = 0;

let AllowPlayerDive = false;
let IsPlayerTransferring = false;
let WakaLayer = MaxLayer;
let LastWakaLayer = WakaLayer;

@Event{
	alternative(GetEventType)
	//1;500;2500
	case(EV_REQUEST_LIFE){SetScriptResult(500+10*(argument/12-4));}
	case(EV_REQUEST_TIMER){SetScriptResult(9999999999-2*(argument/12-4));}
	

	case(EV_USER+177){
		LocalLayer++;
		if(LocalLayer > MaxLayer){LocalLayer = 0;}
	}
}

@Initialize{
	Enemy = CreateBossObject(imgEnemy, 0, 0, 512, 512);
	SetEnemyAnimationA1(Enemy);
	ObjMove_SetDestAtWeight(Enemy, GetCommonData("StarX1", GetStgFrameWidth/2),
		GetCommonData("StarY1", GetStgFrameHeight/3), 13, 5);
		
	SetInvincibility(Enemy, 260, 11, 8);
	PlayEnemyHitSound(Enemy, 1);
	
	SetCommonData("FiredDive", false);
	SetCommonData("DiveLayer", MaxLayer);
	SetCommonData("CanSwapLayer", true);
	BossActions;
}

@MainLoop{
	if(!EnemyDead){
		EnemyX = ObjMove_GetX(Enemy);
		EnemyY = ObjMove_GetY(Enemy);
		
		
		SetCommonData("WakaLayer", WakaLayer);
		SetCommonData("LocalLayer", LocalLayer);
		SetCommonData("Star1X", EnemyX);
		SetCommonData("Star1Y", EnemyY);
		
		
		if(LastWakaLayer != WakaLayer){
			LastWakaLayer = WakaLayer;
			ObjAnim_SetRectOffsetY(0);
		}
		if(WakaLayer == LocalLayer){
			ObjRender_SetAlpha(Enemy, 255);
			ObjRender_SetColor(Enemy, 255, 255, 255);
			ObjEnemy_SetIntersectionCircleToShot(Enemy, EnemyX, EnemyY, 24);
			ObjEnemy_SetIntersectionCircleToPlayer(Enemy, EnemyX, EnemyY, 18);
			ObjRender_SetAngleZ(Enemy, 0);
			ObjAnim_SetAttackA1(Enemy, false);
			
			if(WakaLayer == 0){
				ObjAnim_SetRectOffsetY(160);
			}else{
				ObjAnim_SetRectOffsetY(0);
			}
			
		}else{
			ObjAnim_SetRectOffsetY(0);
			ObjAnim_SetAttackA1(Enemy, true);
			
			if(WakaLayer == MaxLayer){
				ObjRender_SetAlpha(Enemy, 144);
				ObjRender_SetColor(Enemy, 128, 128, 255);
			}/* else{
			} */
		}
		
		if(IsPlayerTransferring){
			SetForbidPlayerShot(true);
			SetForbidPlayerSpell(true);
		}else{
			SetForbidPlayerShot(false);
			SetForbidPlayerSpell(false);
		}
		
		if(GetVirtualKeyState(VK_USER2)==KEY_PUSH && GetCommonData("CanSwapLayer", true) && AllowPlayerDive){
			SetCommonData("FiredDive", true);
		}
	}
	Duration = GetCommonData("DiveDuration", 20);
	IsPlayerTransferring = GetCommonData("IsPlayerTransferring", false);
	CurDur = GetCommonData("DiveCount", 0);
	yield;
}

task BossActions{
	yield;
	PerformActions;
	
	SetCommonData("BGMod", 0);
	loop(90){yield;}
	while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
		yield;
	}
	
	//ExplosionB2(Enemy,"MAPLE",[255, 16, 64],[255, 16, 64]);
	//loop(90){yield;}
	Obj_Delete(Enemy);
	EnemyDead = true;
	PlaySound("se_tan00");
	yield;
	DeleteShotAll(TYPE_ALL, TYPE_ITEM);

	SetCommonData("BGMod", 1);
	loop(256){yield;}
	CloseScript(GetOwnScriptID);
	
	task PerformActions{
		let spname = GetDifficultyVariableB1([
			"Longevity \"Elusive Ningyo Flesh\" "
		]);
		//ObjCutin_SetSpellcardLayersM3(0, [face~"04.png"]);
		//ObjCutin_SetSpellcardM3(spname, , "YABUSAME", , 128, 192, 255);
		
		//name, points, type, image, r, g, b
		ObjCutin_SetSpellcardM4(spname, 3500000, "YABUSAME", face~"00.png", 128, 192, 255);
		ObjCutin_SetSpellcardLayersM4([face~"10.png"]);
		yield;
		ObjEnemyBossScene_StartSpell(objScene);
		//return;
		PlaySoundB1("se_cat00", 105);
		Hold(60);
		ConcentrationA1(Enemy,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);
		Hold(60);
		NotifyEventAll(EV_SIGIL_ON, 0);
		PlaySoundB1("se_boon01",60);
		Hold(40);
		
		if(!Hold(80)){break;}
		AssignWaterGraphics;
		//FireInfSpiral;
		//return;
		
		SplashA1(Enemy);
		if(!Hold(5)){break;}
		WakaLayer = 0;
		if(!Hold(90)){break;}
		ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
		if(!Hold(90)){break;}
		//Fountain(WakaLayer);
		SpamInt;
		 if(!Hold(120)){break;}
		 ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
		 if(!Hold(120)){break;}
		 ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
		 if(!Hold(720)){break;}
		 DeleteShotAll(TYPE_ALL, TYPE_FADE);
		//dialog
		CreateEventTW1(
			[pface~"00.png", face~"00.png"], 
			[pface, face], 
			[
				["08", "05"], 
				["08", "10"],
				["08", "05"], 
				["07", "05"], 
				["07", "10"]
			], 
			[
				0,
				1,
				0,
				0,
				1
			], 
			[
				PlayerText~"...Resorting to cheap tactics by (RR)staying below and shooting are we?", 
				EnemyText~"That's the idea.",
				PlayerText~"I'm going in after her, (RR)I can dive and surface too, you know.", 
				PlayerText~"It's as easy as pushing V. (RR)hint hint", 
				EnemyText~"I doubt you can keep up with a mermaid in her element."
			]);
		AllowPlayerDive = true;	
		if(!Hold(90)){break;}
		Spam;
		while(ObjEnemy_GetInfo(Enemy, INFO_LIFE) > 0 && !EnemyDead){
			
			if(!Hold(40)){break;}
			Fountain(WakaLayer);
			if(!Hold(120)){break;}
			//WakaDive;
			ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
			if(!Hold(180)){break;}
			WakaDiveR;
			if(!Hold(120)){break;}
			Giantwave(WakaLayer);
			if(!Hold(240)){break;}
			Sweep(WakaLayer);
			if(!Hold(70)){break;}
			ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
			if(!Hold(70)){break;}
			ObjMove_SetDestAtWeightLimitedA1(Enemy,GetStgFrameWidth/2+rand(-70,70),GetStgFrameHeight/3+rand(-70,70),120,3,6,6,3);
			if(!Hold(90)){break;}
			WakaDive;
			if(!Hold(60)){break;}
			Ripple(WakaLayer);
			if(!Hold(45)){break;}
			WakaDiveR;
			if(!Hold(150)){break;}
			
			//WakaDive;
			//WakaDiveR;
			
			
		}
		
		task FireInfSpiral{
			let ang = 0;
			FireMoreInfSpiral;
			while(!EnemyDead){
				ang+=7.4*4;
				ascent(i in 0..5){
					// let lang = ang+360/4*i;
					// CreateLayerShotA1(EnemyX, EnemyY, 3, lang, 44+i%2, 10, i%2);
					CreateLayerShotA1(32+(GetStgFrameWidth-32)/10*i, 32, 1.5, 90, 44, 10, 0);
					yield;
				}
				
				CreateLayerShotA1(48, 30, 1.5, 90-25, 45, 10, 1);
				CreateLayerShotA1(GetStgFrameWidth-48, 30, 1.5, 90+25, 44, 10, 0);
				
				
				
				// Hold(8);
			}
			
			task FireMoreInfSpiral{
				while(!EnemyDead){
					ascent(i in 0..5){
						CreateLayerShotA1(GetStgFrameWidth/2+32+(GetStgFrameWidth-32)/10*i, 32, 1.5, 90, 45, 10, 1);
						yield;
					}
				}
			}
		}
		
		task AssignWaterGraphics{
			let LastLayer = LocalLayer;
			let pathShader = current~"../../../ds_system/shader/warp.hlsl";
			let water = ID_INVALID;
			let IsActive = false;
			
			SetCommonData("BGMod", 0);
			
			let mov = 0;
			
			SetCommonData("DiveLayerMax", MaxLayer);
			return;
			while(!EnemyDead){
				mov+=0.6;
				ObjShader_SetFloat(Enemy, "p_frame", mov);
				if(LastLayer != LocalLayer){
					SetCommonData("DiveLayer", LocalLayer);
					if(LocalLayer != MaxLayer){
						if(!IsActive){
							// water = ObjPrim_Create(OBJ_SPRITE_2D);
							
							// ObjShader_SetShaderF(water, pathShader);
							// ObjShader_SetTechnique(water, "TecMain");
							// ObjShader_SetFloat(water, "p_int", 0.025);
							// SetShader(water, 0.2, 0.79);
							
							
							IsActive = true;
							WriteLog("ON");
						}
					}else{
						if(IsActive){
							// ResetShader(0.2, 0.79);
							// Obj_Delete(water);
							IsActive = false;
							WriteLog("OFF");
						}
					}
					LastLayer = LocalLayer;
				}
				yield;
			}
			
		}
		
	}
}

function CreateLayerShotA1(x, y, spd, ang, graph, delay, layer){
	let a = CreateCollisionShotA1(x, y, spd, ang, graph, 0);
	DoLayerStuff(a, layer);
	return a;
}

task DoLayerStuff(a, layer){
	let IsActive = true;
	
	
	
	//scl, alpha, r, g, b
	let OffStats = [0.75, 0, 128, 128, 164];
	if(layer == MaxLayer){
		OffStats = [2, 0, 96, 96, 132];
	}
	
	let CurStats = [1, 255, 255, 255, 255];
	let DefStats = [1, 255, 255, 255, 255];
	
	
	let LocalPlayerTrans = false;
	
	// if(LocalLayer!=layer){
		// MoveBulToValue(1, -1, 0, false);
		
	// if(IsPlayerTransferring){
		// if(LocalLayer == layer){
			// CurStats = OffStats;
		// }
		// ObjRender_SetBlendType(a, BLEND_ADD_ARGB);
		// LocalPlayerTrans = IsPlayerTransferring;
		// SwapLayer(CurDur, Duration);
	// }else{
		if(LocalLayer!=layer){
			SwapLayer(0, 0);
		}
	// }
	
	
	
	
	while(!Obj_IsDeleted(a)){
		if(LocalPlayerTrans != IsPlayerTransferring){
			LocalPlayerTrans = IsPlayerTransferring;
			
			if(IsPlayerTransferring){
				SwapLayer(CurDur, Duration);
			}
		}
		yield;
	}
	
	task SwapLayer(dstar, duration){
		//scl, alpha, r, g, b
		
		
		Obj_SetValue(a, "g_Coll_Ignore", false);
		ObjShot_SetIntersectionEnable(a, false);
		ObjShot_SetSpellResist(a, false);
		
		let m2 = 1;
		
		let DiffStats = CurStats-OffStats;
		if(!IsActive){DiffStats = CurStats-DefStats;m2 = 0.6;}
		
		Obj_SetVisible(a, true);
		
		let sclo = CurStats[0];
		let scld = DiffStats[0];
		
		let alpo = CurStats[1];
		let alpd = DiffStats[1];
		
		
		ascent(i in dstar..duration){
			let mod = (i)/(duration-1);
			
			let scl = sclo-scld*mod;
			let alpdiff = alpo-alpd*mod;
			// let rd = CurStats[2]-DiffStats[2]*mod;
			// let gd = CurStats[3]-DiffStats[3]*mod;
			// let bd = CurStats[4]-DiffStats[4]*mod;
			
			ObjRender_SetScaleXYZ(a, scl, scl, 1);
			ObjRender_SetAlpha(a, alpdiff);
			
			// ObjRender_SetColor(a, rd, gd, bd);
			
			yield;
		}
		
		if(duration == 0 || dstar == duration){
			let scldiff = CurStats[0]-DiffStats[0];
			let alpdiff = CurStats[1]-DiffStats[1];
			
			let scl = scldiff;
			ObjRender_SetScaleXYZ(a, scl, scl, 1);
			ObjRender_SetAlpha(a, alpdiff);
			
		}
		
		// let rd = CurStats[2]-DiffStats[2];
		// let gd = CurStats[3]-DiffStats[3];
		// let bd = CurStats[4]-DiffStats[4];
		// ObjRender_SetColor(a, rd, gd, bd);
		
		
		
		CurStats = OffStats;
		
		
		if(!IsActive){CurStats = DefStats;}
		IsActive = !IsActive;
		Obj_SetVisible(a, IsActive);
		ObjShot_SetIntersectionEnable(a, IsActive);
		ObjShot_SetSpellResist(a, !IsActive);
		Obj_SetValue(a, "g_Coll_Ignore", !IsActive);
		
		// loop(1){yield;}
		
		// if(IsActive && LocalLayer != layer){
			// SwapLayer(0, 0);
		// }
	}
	
	// task MoveBulToValue(base, mod, time, isactive){
		// ObjShot_SetIntersectionEnable(a, isactive);
		// IsActive = isactive;
		// ObjShot_SetIntersectionEnable(a, false);
		// let scl = 3/((layer+1)^2)-1;
		// ascent(i in 0..time){
			// let lmod = base+mod/time*i;
			// ObjRender_SetColor(a, 96+159*lmod, 96+159*lmod, 144+111*lmod);
			// ObjRender_SetAlpha(a, 48+207*lmod);
			// ObjRender_SetScaleXYZ(a, 1+scl*lmod, 1+scl*lmod, 1);
			// yield;
		// }
		// let lmod = base+mod;
		// ObjRender_SetColor(a, 96+159*lmod, 96+159*lmod, 144+111*lmod);
		// ObjRender_SetAlpha(a, 48+207*lmod);
		// ObjRender_SetScaleXYZ(a, 1+scl*lmod, 1+scl*lmod, 1);
		
	// }
}

task ResumeDeletion(obj,time){
	ObjShot_SetAutoDelete(obj, false);
	loop(time){yield;}
	ObjShot_SetAutoDelete(obj, true);
}

/*task Depths{
	while(!EnemyDead){
		let X = rand(0,GetStgFrameWidth+10);
		let shot = CreateLayerShotA1(X,rand(-40,-5),1,90,67,0,0);
		swerve(shot,1,2,90,1);
		Hold(25);
	}
}

task Surface{
	while(!EnemyDead){
		let X = rand(0,GetStgFrameWidth);
		let shot = CreateLayerShotA1(X,rand(-40,-5),2,90,12,0,1);
		Hold(20);
	}
}

task swerve(obj,amt,speed,startpoint,time){
	Hold(time);
	let flux = startpoint;
	while(!Obj_IsDeleted(obj)) {
		flux+=speed;
		ObjMove_SetAngularVelocity(obj,0+amt*sin(flux));
		yield;
	}
}*/

task Fountain(layer){
	let dir = rand(0,360);
	let ot = 0;
	if (layer == 0){ot = 1;}
	if (layer == 1){ot = 0;}
	loop(2){
	loop(10){
	ascent(i in 0..36){
		if (i%2 == 0) {let shot = CreateShotB2(EnemyX,(EnemyY),1.5*cos(dir),-1.2-(0.5*sin(dir)),0,0.01,0,3,186,10);
		GiveCollision(shot);
		DoLayerStuff(shot,layer); 
		let otshot = CreateShotB2(EnemyX,(EnemyY),1.5*cos(dir),-1.2-(0.5*sin(-dir)),0,0.01,0,3,188,10); 
		GiveCollision(otshot); DoLayerStuff(otshot, ot);}
		dir+=360/36;
	}
	dir+=1.2;
	PlaySoundB1("se_kira00",50);
	Hold(5);
	}
	Hold(20);
	dir = rand(0,360);
	loop(10){
	ascent(i in 0..36){
		if (i%2 == 0) {let shot = CreateShotB2(EnemyX,(EnemyY),1.5*cos(dir),-1.2-(0.5*sin(dir)),0,0.01,0,3,186,10);
		GiveCollision(shot);
		DoLayerStuff(shot,layer);
		let otshot = CreateShotB2(EnemyX,(EnemyY),1.5*cos(-dir),-1.2-(0.5*sin(-dir)),0,0.01,0,3,188,10); 
		GiveCollision(otshot); DoLayerStuff(otshot, ot);}
		dir+=360/36;
	}
	dir-=1.2;
	PlaySoundB1("se_kira00",50);
	Hold(5);
	}
	Hold(60);
	}
}

/*task Bubbles(layer){
	let dir = rand(0,360);
	let ot = 0;
	if (layer == 0){ot = 1;}
	if (layer == 1){ot = 0;}
	let color = 141;
	ascent(i in 0..10){
		if (i == 3) {color = 5;}
		if (i == 5) {color = 93;}
		if (i == 7) {color = 256;}
		ascent(j in 0..24){
			let shot = CreateShotA1(EnemyX+90*cos(dir),(EnemyY-40)+90*sin(dir),2.5,dir,color,10);
			DoLayerStuff(shot, layer);
			let otshot = CreateShotA1(EnemyX+90*cos(dir),(EnemyY-40)+90*sin(dir),2.5,dir,color,10); 
			DoLayerStuff(otshot, ot);
			dir+=360/24;
		}
	dir+=360/24/2;
	Hold(30);
	}
}*/

task Spam{
	let ot = 0;
	let dir = 0;
	while(!EnemyDead){
	ascent(i in 0..2){
		loop(20){
			if (WakaLayer == 0){ot = 1;}
			if (WakaLayer == 1){ot = 0;}
			if (i%2 == 0) {let shot = CreateCollisionShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2,dir,16,10); DoLayerStuff(shot, WakaLayer); ObjMove_SetAngularVelocity(shot,rand(-0.2,0.2));}
			let otshot = CreateCollisionShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2,dir,12,10);
			DoLayerStuff(otshot, ot);
			ObjMove_SetAngularVelocity(otshot,rand(-0.2,0.2));
			dir+=360/20;
			}
		PlaySoundB1("se_tan00",20);
		Hold(30);
		dir+=360/20/4;
		}
	}
}

task SpamInt{
	let ot = 0;
	let dir = 0;
	ascent(i in 0..33){
		loop(20){
			if (WakaLayer == 0){ot = 1;}
			if (WakaLayer == 1){ot = 0;}
			//if (i%2 == 0) {let shot = CreateShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2,dir,12,10); DoLayerStuff(shot, WakaLayer); ObjMove_SetAngularVelocity(shot,rand(-0.2,0.2));}
			let otshot = CreateCollisionShotA1(EnemyX+30*cos(dir),EnemyY+30*sin(dir),2,dir,12,10);
			DoLayerStuff(otshot, ot);
			ObjMove_SetAngularVelocity(otshot,rand(-0.2,0.2));
			dir+=360/20;
			}
		PlaySoundB1("se_tan00",20);
		Hold(30);
		dir+=360/20/4;
	}
}

task Sweep(layer){
	let dir = 270;
	loop(90){
		ascent(i in 1..4){
			let shot = CreateCollisionShotA1(EnemyX,EnemyY,1+(i*0.6),dir*i,62,20);
			DoLayerStuff(shot, 0);
			ObjMove_SetAngularVelocity(shot,0-(i*0.1));
			let otshot = CreateCollisionShotA1(EnemyX,EnemyY,1+(i*0.6),270-(dir-270)*i,60,20);
			DoLayerStuff(otshot, 1);
			ObjMove_SetAngularVelocity(otshot,0+(i*0.1));
			dir+=3.2;
		}
		PlaySoundB1("c_shot3",50);
		Hold(2);
	}
}

task Giantwave(layer){
	Hold(80);
	let dir = 90;
	let spread = -180;
	PlaySoundB1("se_don00", 80);
	ascent(b in 0..95){
		ascent(i in 0..3) {
			let shot = CreateLayerShotA1(EnemyX,EnemyY,1-(i*0.2)+rand(0.1,0.3),dir+spread,rand(237,241),15,layer);
		}
		spread+=360/94;
	}
}

task Ripple(layer){
	let dir = rand(0,360);
	let ot = 0;
	if (WakaLayer == 0){ot = 1;}
	if (WakaLayer == 1){ot = 0;}
	PlaySoundB1("c_shot3",50);
	loop(6){
		let spread = -20;
		loop(5){
			ascent(i in 0..10){
				let otshot = CreateCollisionShotA1(EnemyX+90*cos(dir+spread),(EnemyY-60)+90*sin(dir+spread),1.3-(i*0.2),dir+spread,1+i,20);
				ObjMove_AddPatternA3(otshot,90,1.3-(i*0.2),NO_CHANGE,0.01,0,1.3+(i*0.1),NO_CHANGE);
				let shot = CreateCollisionShotA1(EnemyX+90*cos(dir+spread),(EnemyY-60)+90*sin(dir+spread),1.3-(i*0.2),dir+spread,137+i,20);
				ObjMove_AddPatternA3(shot,60,1.3-(i*0.2),NO_CHANGE,0,i*0.5,1.3-(i*0.2),NO_CHANGE);
				ObjMove_AddPatternA3(shot,90,1.3-(i*0.2),NO_CHANGE,0.01,0,1.3+(i*0.1),NO_CHANGE);
				DoLayerStuff(shot, WakaLayer);
				DoLayerStuff(otshot, ot);
			}
			spread+=40/5;
		}
		dir+=360/6;
	}
	dir+=360/6/2;
	Hold(90);
	PlaySoundB1("c_shot3",50);
	if (WakaLayer == 0){ot = 1;}
	if (WakaLayer == 1){ot = 0;}
	loop(6){
		let spread = -20;
		loop(5){
			ascent(i in 0..10){
				let otshot = CreateCollisionShotA1(EnemyX+90*cos(dir+spread),(EnemyY-60)+90*sin(dir+spread),1.3-(i*0.2),dir+spread,1+i,20);
				ObjMove_AddPatternA3(otshot,90,1.3-(i*0.2),NO_CHANGE,0.01,0,1.3+(i*0.1),NO_CHANGE);
				let shot = CreateCollisionShotA1(EnemyX+90*cos(dir+spread),(EnemyY-60)+90*sin(dir+spread),1.3-(i*0.2),dir+spread,137+i,20);
				ObjMove_AddPatternA3(shot,60,1.3-(i*0.2),NO_CHANGE,0,-i*0.5,1.3-(i*0.2),NO_CHANGE);
				ObjMove_AddPatternA3(shot,90,1.3-(i*0.2),NO_CHANGE,0.01,0,1.3+(i*0.1),NO_CHANGE);
				DoLayerStuff(shot, WakaLayer);
				DoLayerStuff(otshot, ot);
			}
			spread+=40/5;
		}
		dir+=360/6;
	}
}

task SplashA1(obj){
	let img = ObjPrim_Create(OBJ_SPRITE_2D);
	ObjPrim_SetTexture(img,imgSplash);
	let op = 0;
	let size = 0;
	let hi = 0;
	let X = ObjMove_GetX(obj);
	let Y = ObjMove_GetY(obj);
	ObjSprite2D_SetSourceRect(img,0,0,64,64);
	ObjSprite2D_SetDestCenter(img);
	Obj_SetRenderPriorityI(img,55);
	ObjRender_SetAlpha(img,op);
	ObjRender_SetPosition(img,X,Y,0);
	PlaySoundB1("se_water",60);
	loop(5){
		ObjRender_SetAlpha(img,op);
		ObjRender_SetScaleXYZ(img,size,size,0);
		ObjRender_SetPosition(img,X,Y-hi,0);
		op+=255/5;
		size+=1.2/5;
		hi+=1.2;
		yield;
	}
	loop(10){
		ObjRender_SetAlpha(img,op);
		ObjRender_SetScaleXYZ(img,size,size,0);
		ObjRender_SetPosition(img,X,Y-hi,0);
		op-=255/10;
		size+=1.2/10;
		hi+=1.2;
		yield;
	}
	Obj_Delete(img);
}

task WakaDive{
	let lay = 0;
	if (WakaLayer == 0) {lay = 1;}
	if (WakaLayer == 1) {lay = 0;}
	ConcentrationA1(Enemy,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);
	if(!Hold(90)){break;}
	SplashA1(Enemy);
	Hold(5);
	WakaLayer = lay;
}

task WakaDiveR{
	let chance = round(rand(0,1));
	if (WakaLayer == chance) {return;}
	ConcentrationA1(Enemy,"CHERRY",80,3,110,[0,56,255]); PlaySoundB1("se_ch02", 65);
	if(!Hold(90)){break;}
	SplashA1(Enemy);
	Hold(5);
	WakaLayer = chance;
}